/***************************************************************************
 *   Copyright (C) 2004 by Marco Gulino                                    *
 *   marco.gulino@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef D_SMSLIST_H
#define D_SMSLIST_H

#include <qwidget.h>
#include <kdialogbase.h>

#include "c_sms.h"
#include "c_smslist.h"
#include "ui_SMSList.h"

/**
@author Marco Gulino
*/
class d_SMSList : public KDialogBase
{
Q_OBJECT
public:
    d_SMSList(QWidget *parent = 0, const char *name = 0);

    ~d_SMSList();
    void initList();

public slots:
    void selectionChanged( QListViewItem* item);
    void changedFilter(int);
    void deleteSMS();
    void slotUser1();
    void slotUser2();
    void slotUser3();
    void sendSMS();
    void saveSMS();
    void refreshSMSList();
private:
	ui_SMSList* mainWidget;
	QPtrList<int> smsList;
};

#endif
